From 2fd5cee0159dc1b2cdbe02926c58178f91927d6f Mon Sep 17 00:00:00 2001
From: Nick Steel <nick@nsteel.co.uk>
Date: Sun, 26 Jun 2022 01:30:48 +0100
Subject: [PATCH 11/21] Remove pyspotify: browse

Removed generic toplists, unavailable through Web API?
---
 mopidy_spotify/browse.py | 155 ++++---------------
 mopidy_spotify/web.py    |  27 +++-
 tests/test_browse.py     | 323 +++++----------------------------------
 tests/test_web.py        |  37 ++++-
 4 files changed, 122 insertions(+), 420 deletions(-)

diff --git a/mopidy_spotify/browse.py b/mopidy_spotify/browse.py
index 37a579d6..425c92e9 100644
--- a/mopidy_spotify/browse.py
+++ b/mopidy_spotify/browse.py
@@ -4,6 +4,7 @@
 
 import spotify
 from mopidy_spotify import countries, playlists, translator
+from mopidy_spotify.web import WebLink
 from mopidy_spotify.utils import flatten
 
 logger = logging.getLogger(__name__)
@@ -22,7 +23,6 @@
 
 _TOP_LIST_DIR_CONTENTS = [
     models.Ref.directory(uri="spotify:top:tracks", name="Top tracks"),
-    models.Ref.directory(uri="spotify:top:albums", name="Top albums"),
     models.Ref.directory(uri="spotify:top:artists", name="Top artists"),
 ]
 
@@ -35,17 +35,6 @@
     models.Ref.directory(uri="spotify:playlists:featured", name="Featured"),
 ]
 
-_TOPLIST_TYPES = {
-    "albums": spotify.ToplistType.ALBUMS,
-    "artists": spotify.ToplistType.ARTISTS,
-    "tracks": spotify.ToplistType.TRACKS,
-}
-
-_TOPLIST_REGIONS = {
-    "country": lambda session: session.user_country,
-    "everywhere": lambda session: spotify.ToplistRegion.EVERYWHERE,
-}
-
 
 def browse(*, config, session, web_client, uri):
     if uri == ROOT_DIR.uri:
@@ -56,22 +45,21 @@ def browse(*, config, session, web_client, uri):
         return _YOUR_MUSIC_DIR_CONTENTS
     elif uri == _PLAYLISTS_DIR.uri:
         return _PLAYLISTS_DIR_CONTENTS
-    elif uri.startswith("spotify:user:") or uri.startswith("spotify:playlist:"):
-        return _browse_playlist(web_client, uri, config)
+
+    if web_client is None or not web_client.logged_in:
+        return []
+
+    #TODO: Support for category browsing.
+    if uri.startswith("spotify:user:") or uri.startswith("spotify:playlist:"):
+        return _browse_playlist(web_client, uri)
     elif uri.startswith("spotify:album:"):
-        return _browse_album(session, uri, config)
+        return _browse_album(web_client, uri)
     elif uri.startswith("spotify:artist:"):
-        return _browse_artist(session, uri, config)
+        return _browse_artist(web_client, uri)
     elif uri.startswith("spotify:top:"):
         parts = uri.replace("spotify:top:", "").split(":")
         if len(parts) == 1:
-            return _browse_toplist_regions(variant=parts[0])
-        elif len(parts) == 2:
-            if parts[1] == "user":
-                return _browse_toplist_user(web_client, variant=parts[0])
-            return _browse_toplist(
-                config, session, variant=parts[0], region=parts[1]
-            )
+            return _browse_toplist_user(web_client, variant=parts[0])
         else:
             logger.info(f"Failed to browse {uri!r}: Toplist URI parsing failed")
             return []
@@ -88,66 +76,36 @@ def browse(*, config, session, web_client, uri):
     return []
 
 
-def _browse_playlist(web_client, uri, config):
-    return playlists.playlist_lookup(
-        web_client, uri, config["bitrate"], as_items=True
-    )
+def _browse_playlist(web_client, uri):
+    return playlists.playlist_lookup(web_client, uri, None, as_items=True)
 
 
-def _browse_album(session, uri, config):
-    if session is None or session.connection.state is not spotify.ConnectionState.LOGGED_IN:
+def _browse_album(web_client, uri):
+    try:
+        link = WebLink.from_uri(uri)
+    except ValueError as exc:
+        logger.info(f"Failed to browse {uri!r}: {exc}")
         return []
 
-    sp_album_browser = session.get_album(uri).browse()
-    sp_album_browser.load(config["timeout"])
-    return list(
-        translator.to_track_refs(
-            sp_album_browser.tracks, timeout=config["timeout"]
-        )
-    )
+    web_album = web_client.get_album(link)
+    web_tracks = web_album.get("tracks", {}).get("items", [])
+    return list(translator.web_to_track_refs(web_tracks))
 
 
-def _browse_artist(session, uri, config):
-    if session is None or session.connection.state is not spotify.ConnectionState.LOGGED_IN:
+def _browse_artist(web_client, uri):
+    try:
+        link = WebLink.from_uri(uri)
+    except ValueError as exc:
+        logger.info(f"Failed to browse {uri!r}: {exc}")
         return []
 
-    sp_artist_browser = session.get_artist(uri).browse(
-        type=spotify.ArtistBrowserType.NO_TRACKS
-    )
-    sp_artist_browser.load(config["timeout"])
-    top_tracks = list(
-        translator.to_track_refs(
-            sp_artist_browser.tophit_tracks, timeout=config["timeout"]
-        )
-    )
-    albums = list(
-        translator.to_album_refs(
-            sp_artist_browser.albums, timeout=config["timeout"]
-        )
-    )
-    return top_tracks + albums
+    web_top_tracks = web_client.get_artist_top_tracks(link)
+    top_tracks = list(translator.web_to_track_refs(web_top_tracks))
 
+    web_albums = web_client.get_artist_albums(link, all_tracks=False)
+    albums = list(translator.web_to_album_refs(web_albums))
 
-def _browse_toplist_regions(variant):
-    dir_contents = [
-        models.Ref.directory(
-            uri=f"spotify:top:{variant}:country", name="Country"
-        ),
-        models.Ref.directory(
-            uri=f"spotify:top:{variant}:countries", name="Other countries"
-        ),
-        models.Ref.directory(
-            uri=f"spotify:top:{variant}:everywhere", name="Global"
-        ),
-    ]
-    if variant in ("tracks", "artists"):
-        dir_contents.insert(
-            0,
-            models.Ref.directory(
-                uri=f"spotify:top:{variant}:user", name="Personal"
-            ),
-        )
-    return dir_contents
+    return top_tracks + albums
 
 
 def _browse_toplist_user(web_client, variant):
@@ -175,57 +133,6 @@ def _browse_toplist_user(web_client, variant):
         return []
 
 
-def _browse_toplist(config, session, variant, region):
-    if session is None:
-        return []
-    if region == "countries":
-        codes = config["toplist_countries"]
-        if not codes:
-            codes = countries.COUNTRIES.keys()
-        return [
-            models.Ref.directory(
-                uri=f"spotify:top:{variant}:{code.lower()}",
-                name=countries.COUNTRIES.get(code.upper(), code.upper()),
-            )
-            for code in codes
-        ]
-
-    if region in ("country", "everywhere"):
-        sp_toplist = session.get_toplist(
-            type=_TOPLIST_TYPES[variant],
-            region=_TOPLIST_REGIONS[region](session),
-        )
-    elif len(region) == 2:
-        sp_toplist = session.get_toplist(
-            type=_TOPLIST_TYPES[variant], region=region.upper()
-        )
-    else:
-        return []
-
-    if session.connection.state is spotify.ConnectionState.LOGGED_IN:
-        sp_toplist.load(config["timeout"])
-
-    if not sp_toplist.is_loaded:
-        return []
-
-    if variant == "tracks":
-        return list(translator.to_track_refs(sp_toplist.tracks))
-    elif variant == "albums":
-        return list(
-            translator.to_album_refs(
-                sp_toplist.albums, timeout=config["timeout"]
-            )
-        )
-    elif variant == "artists":
-        return list(
-            translator.to_artist_refs(
-                sp_toplist.artists, timeout=config["timeout"]
-            )
-        )
-    else:
-        return []
-
-
 def _load_your_music(web_client, variant):
     if web_client is None or not web_client.logged_in:
         return
diff --git a/mopidy_spotify/web.py b/mopidy_spotify/web.py
index ee01090a..0a7a1043 100644
--- a/mopidy_spotify/web.py
+++ b/mopidy_spotify/web.py
@@ -493,7 +493,7 @@ def get_album(self, web_link):
         )
         return self._with_all_tracks(album)
 
-    def get_artist_albums(self, web_link):
+    def get_artist_albums(self, web_link, all_tracks=True):
         if web_link.type != LinkType.ARTIST:
             logger.error(f"Expecting Spotify artist URI")
             return []
@@ -504,12 +504,25 @@ def get_artist_albums(self, web_link):
         )
         for page in pages:
             for album in page["items"]:
-                try:
-                    web_link = WebLink.from_uri(album.get("uri"))
-                except ValueError as exc:
-                    logger.error(exc)
-                    continue
-                yield self.get_album(web_link)
+                if all_tracks:
+                    try:
+                        web_link = WebLink.from_uri(album.get("uri"))
+                    except ValueError as exc:
+                        logger.error(exc)
+                        continue
+                    yield self.get_album(web_link)
+                else:
+                    yield album
+
+    def get_artist_top_tracks(self, web_link):
+        if web_link.type != LinkType.ARTIST:
+            logger.error(f"Expecting Spotify artist URI")
+            return []
+
+        return self.get_one(
+            f"artists/{web_link.id}/top-tracks",
+            params={"market": "from_token"},
+        ).get("tracks")
 
     def get_track(self, web_link):
         if web_link.type != LinkType.TRACK:
diff --git a/tests/test_browse.py b/tests/test_browse.py
index e66f18f2..5bfcfaf7 100644
--- a/tests/test_browse.py
+++ b/tests/test_browse.py
@@ -1,5 +1,6 @@
 from unittest import mock
 
+import pytest
 from mopidy import models
 
 import spotify
@@ -25,18 +26,22 @@ def test_browse_root_directory(provider):
     )
 
 
+def test_browse_root_when_offline(web_client_mock, provider):
+    web_client_mock.logged_in = False
+    
+    results = provider.browse("spotify:directory")
+
+    assert len(results) == 3
+
+
 def test_browse_top_lists_directory(provider):
     results = provider.browse("spotify:top")
 
-    assert len(results) == 3
+    assert len(results) == 2
     assert (
         models.Ref.directory(uri="spotify:top:tracks", name="Top tracks")
         in results
     )
-    assert (
-        models.Ref.directory(uri="spotify:top:albums", name="Top albums")
-        in results
-    )
     assert (
         models.Ref.directory(uri="spotify:top:artists", name="Top artists")
         in results
@@ -80,172 +85,59 @@ def test_browse_playlist(web_client_mock, web_playlist_mock, provider):
         uri="spotify:track:abc", name="ABC 123"
     )
 
+@pytest.mark.parametrize(
+    "uri", ["album:def", "artist:abba", "user:alice:playlist:foo", "unknown", "top:tracks", "your:tracks"]
+)
+def test_browse_item_when_offline(web_client_mock, uri, provider, caplog):
+    web_client_mock.logged_in = False
 
-def test_browse_album_when_offline(session_mock, sp_album_mock, provider):
-    session_mock.connection.state = spotify.ConnectionState.OFFLINE
-    session_mock.get_album.return_value = sp_album_mock
-    sp_album_browser_mock = sp_album_mock.browse.return_value
-    sp_album_browser_mock.is_loaded = False
-    type(sp_album_browser_mock).tracks = mock.PropertyMock(
-        side_effect=Exception
-    )
+    results = provider.browse(f"spotify:{uri}")
 
-    provider.browse("spotify:album:def")
-
-    assert sp_album_browser_mock.load.call_count == 0
+    assert len(results) == 0
+    assert "Failed to browse" not in caplog.text
 
 
-def test_browse_album(
-    session_mock, sp_album_mock, sp_album_browser_mock, sp_track_mock, provider
-):
-    session_mock.get_album.return_value = sp_album_mock
-    sp_album_mock.browse.return_value = sp_album_browser_mock
-    sp_album_browser_mock.tracks = [sp_track_mock, sp_track_mock]
+def test_browse_album(web_client_mock, web_album_mock, provider):
+    web_client_mock.get_album.return_value = web_album_mock
 
     results = provider.browse("spotify:album:def")
 
-    session_mock.get_album.assert_called_once_with("spotify:album:def")
-    sp_album_mock.browse.assert_called_once_with()
-    assert len(results) == 2
+    assert len(results) == 10
     assert results[0] == models.Ref.track(
         uri="spotify:track:abc", name="ABC 123"
     )
 
 
-def test_browse_artist_when_offline(session_mock, sp_artist_mock, provider):
-    session_mock.connection.state = spotify.ConnectionState.OFFLINE
-    session_mock.get_artist.return_value = sp_artist_mock
-    sp_artist_browser_mock = sp_artist_mock.browse.return_value
-    sp_artist_browser_mock.is_loaded = False
-    type(sp_artist_browser_mock).tophit_tracks = mock.PropertyMock(
-        side_effect=Exception
-    )
-    type(sp_artist_browser_mock).albums = mock.PropertyMock(
-        side_effect=Exception
-    )
+def test_browse_album_bad_uri(web_client_mock, web_album_mock, provider, caplog):
+    web_client_mock.get_album.return_value = web_album_mock
 
-    provider.browse("spotify:artist:abba")
+    results = provider.browse("spotify:album:def:xyz")
 
-    assert sp_artist_browser_mock.load.call_count == 0
+    assert len(results) == 0
+    assert "Failed to browse" in caplog.text
 
 
 def test_browse_artist(
-    session_mock,
-    sp_artist_mock,
-    sp_artist_browser_mock,
-    sp_album_mock,
-    sp_track_mock,
+    web_client_mock,
+    web_album_mock_base,
+    web_track_mock,
     provider,
 ):
-    session_mock.get_artist.return_value = sp_artist_mock
-    sp_artist_mock.browse.return_value = sp_artist_browser_mock
-    sp_artist_browser_mock.albums = [sp_album_mock, sp_album_mock]
-    sp_artist_browser_mock.tophit_tracks = [sp_track_mock, sp_track_mock]
-
+    web_client_mock.get_artist_albums.return_value = [web_album_mock_base]
+    web_client_mock.get_artist_top_tracks.return_value = [web_track_mock, web_track_mock, web_track_mock]
+    
     results = provider.browse("spotify:artist:abba")
 
-    session_mock.get_artist.assert_called_once_with("spotify:artist:abba")
-    sp_artist_mock.browse.assert_called_once_with(
-        type=spotify.ArtistBrowserType.NO_TRACKS
-    )
+    web_client_mock.get_artist_albums.assert_called_once_with(mock.ANY, all_tracks=False)
     assert len(results) == 4
     assert results[0] == models.Ref.track(
         uri="spotify:track:abc", name="ABC 123"
     )
-    assert results[2] == models.Ref.album(
+    assert results[3] == models.Ref.album(
         uri="spotify:album:def", name="ABBA - DEF 456"
     )
 
 
-def test_browse_toplist_when_offline(session_mock, provider):
-    session_mock.connection.state = spotify.ConnectionState.OFFLINE
-    toplist_mock = session_mock.get_toplist.return_value
-    toplist_mock.is_loaded = False
-    type(toplist_mock).tracks = mock.PropertyMock(side_effect=Exception)
-
-    provider.browse("spotify:top:tracks:country")
-
-    assert toplist_mock.load.call_count == 0
-
-
-def test_browse_toplist_when_offline_web(web_client_mock, provider):
-    web_client_mock.user_id = None
-
-    results = provider.browse("spotify:top:tracks:user")
-
-    assert len(results) == 0
-
-
-def test_browse_top_tracks(provider):
-    results = provider.browse("spotify:top:tracks")
-
-    assert len(results) == 4
-    assert (
-        models.Ref.directory(uri="spotify:top:tracks:user", name="Personal")
-        in results
-    )
-    assert (
-        models.Ref.directory(uri="spotify:top:tracks:country", name="Country")
-        in results
-    )
-    assert (
-        models.Ref.directory(uri="spotify:top:tracks:everywhere", name="Global")
-        in results
-    )
-    assert (
-        models.Ref.directory(
-            uri="spotify:top:tracks:countries", name="Other countries"
-        )
-        in results
-    )
-
-
-def test_browse_top_albums(provider):
-    results = provider.browse("spotify:top:albums")
-
-    assert len(results) == 3
-    assert (
-        models.Ref.directory(uri="spotify:top:albums:country", name="Country")
-        in results
-    )
-    assert (
-        models.Ref.directory(uri="spotify:top:albums:everywhere", name="Global")
-        in results
-    )
-    assert (
-        models.Ref.directory(
-            uri="spotify:top:albums:countries", name="Other countries"
-        )
-        in results
-    )
-
-
-def test_browse_top_artists(provider):
-    results = provider.browse("spotify:top:artists")
-
-    assert len(results) == 4
-    assert (
-        models.Ref.directory(uri="spotify:top:artists:user", name="Personal")
-        in results
-    )
-    assert (
-        models.Ref.directory(uri="spotify:top:artists:country", name="Country")
-        in results
-    )
-    assert (
-        models.Ref.directory(
-            uri="spotify:top:artists:everywhere", name="Global"
-        )
-        in results
-    )
-    assert (
-        models.Ref.directory(
-            uri="spotify:top:artists:countries", name="Other countries"
-        )
-        in results
-    )
-
-
 def test_browse_top_tracks_with_too_many_uri_parts(provider):
     results = provider.browse("spotify:top:tracks:foo:bar")
 
@@ -253,7 +145,7 @@ def test_browse_top_tracks_with_too_many_uri_parts(provider):
 
 
 def test_browse_unsupported_top_tracks(web_client_mock, provider):
-    results = provider.browse("spotify:top:albums:user")
+    results = provider.browse("spotify:top:albums")
 
     web_client_mock.get_one.assert_not_called()
     assert len(results) == 0
@@ -262,7 +154,7 @@ def test_browse_unsupported_top_tracks(web_client_mock, provider):
 def test_browse_personal_top_tracks_empty(web_client_mock, provider):
     web_client_mock.get_all.return_value = [{}]
 
-    results = provider.browse("spotify:top:tracks:user")
+    results = provider.browse("spotify:top:tracks")
 
     web_client_mock.get_all.assert_called_once_with(
         "me/top/tracks", params={"limit": 50}
@@ -278,7 +170,7 @@ def test_browse_personal_top_tracks(web_client_mock, web_track_mock, provider):
         {"items": [web_track_mock, web_track_mock]},
     ]
 
-    results = provider.browse("spotify:top:tracks:user")
+    results = provider.browse("spotify:top:tracks")
 
     web_client_mock.get_all.assert_called_once_with(
         "me/top/tracks", params={"limit": 50}
@@ -289,145 +181,6 @@ def test_browse_personal_top_tracks(web_client_mock, web_track_mock, provider):
     )
 
 
-def test_browse_country_top_tracks(session_mock, sp_track_mock, provider):
-    session_mock.user_country = "NO"
-    session_mock.get_toplist.return_value.tracks = [
-        sp_track_mock,
-        sp_track_mock,
-    ]
-
-    results = provider.browse("spotify:top:tracks:country")
-
-    session_mock.get_toplist.assert_called_once_with(
-        type=spotify.ToplistType.TRACKS, region="NO"
-    )
-    assert len(results) == 2
-    assert results[0] == models.Ref.track(
-        uri="spotify:track:abc", name="ABC 123"
-    )
-
-
-def test_browse_global_top_tracks(session_mock, sp_track_mock, provider):
-    session_mock.get_toplist.return_value.tracks = [
-        sp_track_mock,
-        sp_track_mock,
-    ]
-
-    results = provider.browse("spotify:top:tracks:everywhere")
-
-    session_mock.get_toplist.assert_called_once_with(
-        type=spotify.ToplistType.TRACKS, region=spotify.ToplistRegion.EVERYWHERE
-    )
-    assert len(results) == 2
-    assert results[0] == models.Ref.track(
-        uri="spotify:track:abc", name="ABC 123"
-    )
-
-
-def test_browse_top_track_countries_list_limited_by_config(
-    session_mock, sp_track_mock, provider
-):
-    session_mock.get_toplist.return_value.tracks = [
-        sp_track_mock,
-        sp_track_mock,
-    ]
-
-    results = provider.browse("spotify:top:tracks:countries")
-
-    assert len(results) == 2
-    assert (
-        models.Ref.directory(uri="spotify:top:tracks:gb", name="United Kingdom")
-        in results
-    )
-    assert (
-        models.Ref.directory(uri="spotify:top:tracks:us", name="United States")
-        in results
-    )
-
-
-def test_browse_top_tracks_countries_unlimited_by_config(
-    provider, backend_mock
-):
-    backend_mock._config["spotify"]["toplist_countries"] = []
-
-    results = provider.browse("spotify:top:tracks:countries")
-
-    assert len(results) > 50
-    assert (
-        models.Ref.directory(uri="spotify:top:tracks:jp", name="Japan")
-        in results
-    )
-    assert (
-        models.Ref.directory(uri="spotify:top:tracks:no", name="Norway")
-        in results
-    )
-    assert (
-        models.Ref.directory(uri="spotify:top:tracks:gb", name="United Kingdom")
-        in results
-    )
-    assert (
-        models.Ref.directory(uri="spotify:top:tracks:us", name="United States")
-        in results
-    )
-
-
-def test_browse_other_country_top_tracks(session_mock, sp_track_mock, provider):
-    session_mock.get_toplist.return_value.tracks = [
-        sp_track_mock,
-        sp_track_mock,
-    ]
-
-    results = provider.browse("spotify:top:tracks:us")
-
-    session_mock.get_toplist.assert_called_once_with(
-        type=spotify.ToplistType.TRACKS, region="US"
-    )
-    assert len(results) == 2
-    assert results[0] == models.Ref.track(
-        uri="spotify:track:abc", name="ABC 123"
-    )
-
-
-def test_browse_unknown_country_top_tracks(
-    session_mock, sp_track_mock, provider
-):
-    session_mock.get_toplist.return_value.tracks = [
-        sp_track_mock,
-        sp_track_mock,
-    ]
-
-    results = provider.browse("spotify:top:tracks:aa")
-
-    session_mock.get_toplist.assert_called_once_with(
-        type=spotify.ToplistType.TRACKS, region="AA"
-    )
-    assert len(results) == 2
-    assert results[0] == models.Ref.track(
-        uri="spotify:track:abc", name="ABC 123"
-    )
-
-
-def test_browse_top_albums_countries_list(
-    session_mock, sp_track_mock, provider
-):
-    session_mock.get_toplist.return_value.tracks = [
-        sp_track_mock,
-        sp_track_mock,
-    ]
-
-    results = provider.browse("spotify:top:albums:countries")
-
-    assert len(results) == 2
-    assert (
-        models.Ref.directory(uri="spotify:top:albums:gb", name="United Kingdom")
-        in results
-    )
-    assert (
-        models.Ref.directory(uri="spotify:top:albums:us", name="United States")
-        in results
-    )
-
-
 def test_browse_personal_top_artists(
     web_client_mock, web_artist_mock, provider
 ):
@@ -436,7 +189,7 @@ def test_browse_personal_top_artists(
         {"items": [web_artist_mock, web_artist_mock]},
     ]
 
-    results = provider.browse("spotify:top:artists:user")
+    results = provider.browse("spotify:top:artists")
 
     web_client_mock.get_all.assert_called_once_with(
         "me/top/artists", params={"limit": 50}
diff --git a/tests/test_web.py b/tests/test_web.py
index 1a4a17fe..621439d6 100644
--- a/tests/test_web.py
+++ b/tests/test_web.py
@@ -1154,7 +1154,11 @@ def test_get_album(self, foo_album, foo_album_next_tracks, spotify_client):
         assert result["tracks"]["items"] == [3, 4, 5, 6, 7, 8]
 
     @responses.activate
-    def test_get_artist_albums(self, artist_albums_mock, web_album_mock, web_album_mock2, spotify_client):
+    @pytest.mark.parametrize(
+        "all_tracks,",
+        [(True), (False)],
+    )
+    def test_get_artist_albums(self, artist_albums_mock, web_album_mock, web_album_mock2, spotify_client, all_tracks):
         responses.add(
             responses.GET,
             url("artists/abba/albums"),
@@ -1173,14 +1177,25 @@ def test_get_artist_albums(self, artist_albums_mock, web_album_mock, web_album_m
         )
 
         link = web.WebLink.from_uri("spotify:artist:abba")
-        results = list(spotify_client.get_artist_albums(link))
+        results = list(spotify_client.get_artist_albums(link, all_tracks=all_tracks))
         
-        assert len(responses.calls) == 3
-
+        if all_tracks:
+            assert len(responses.calls) == 3
+        else:
+            assert len(responses.calls) == 1
+            
         assert len(results) == 2
         assert results[0]["name"] == "DEF 456"
         assert results[1]["name"] == "XYZ 789"
 
+        if all_tracks:
+            assert results[0]["tracks"]
+            assert results[1]["tracks"]
+        else:
+            assert "tracks" not in results[0]
+            assert "tracks" not in results[1]
+
+
     @responses.activate
     def test_get_artist_albums_error(self, artist_albums_mock, web_album_mock, spotify_client, caplog):
         responses.add(
@@ -1241,6 +1256,20 @@ def test_get_track(self, web_track_mock, spotify_client, uri, success):
         else:
             assert result == {}
 
+    @responses.activate
+    def test_get_artist_top_tracks(self, web_track_mock, spotify_client):
+        responses.add(
+            responses.GET,
+            url(f"artists/baz/top-tracks"),
+            json={"tracks": [web_track_mock, web_track_mock]},
+        )
+        link = web.WebLink.from_uri("spotify:artist:baz")
+        results = spotify_client.get_artist_top_tracks(link)
+
+        assert len(responses.calls) == 1
+        assert len(results) == 2
+        assert results[0]["name"] == "ABC 123"
+
 
 @pytest.mark.parametrize(
     "uri,type_,id_",

